﻿--local api = require "eu07.events"
local kernel = require "scenery/$lua_test/kernel"

-- drzewo inicjalizacji:

-- lista stacji (array)
	-- stacja 1 (array)
		-- nazwa (string)
		-- skrot (string)
		-- typ (int) - 0: stacja, 1: szlak
		-- dane stacji (array)
			-- izolacje (array)
				-- izolacja 1 (string)
				-- izolacja 2 (string)
				-- izolacja 3 (string)
				-- [...]
			-- zwrotnice (array)
				-- zwrotnica 1 (string)
				-- zwrotnica 2 (string)
				-- zwrotnica 3 (string)
				-- [...]
			-- semafory (array)
				-- semafor 1 (array)
					-- nazwa (string)
					-- semafory za nim (array)
						-- semafor 1 (string)
						-- semafor 2 (string)
						-- semafor 3 (string)
						-- [...]
					-- powtarzacze (array)
						-- powtarzacz 1 (string)
						-- powtarzacz 2 (string)
						-- powtarzacz 3 (string)
						-- [...]
					-- przebiegi (array)
						-- przebieg 1 (array)
							-- nazwa (string)
							-- predkosc (int) - 0: S1, 1: Vmax, 2: 40 km/h, 3: 60 km/h, 4: 100 km/h, 5: Sz, 6: Ms1, 7: Ms2
							-- semafor przed nim (string)
							-- zwrotnice (array)
								-- ustawienie zwrotnicy 1 (string)
								-- ustawienie zwrotnicy 2 (string)
								-- ustawienie zwrotnicy 3 (string)
								-- [...]
							-- izolacje (array)
								-- izolacja 1 (string)
								-- izolacja 2 (string)
								-- izolacja 3 (string)
								-- [...]
						-- przebieg 2 (array)
						-- przebieg 3 (array)
						-- [...]
				-- semafor 2 (array)
				-- semafor 3 (array)
				-- [...]
	-- stacja 2 (array)
	-- stacja 3 (array)
	-- [...]

inicjalizuj(
{
	{										-- stacja 1
		"stacja1",								-- nazwa
		"stacja1",								-- skrot
		0,										-- typ
		{										-- dane
			{										-- izolacje
				"tor1",
				"tor2",
				"zwr1",
				"zwr2"
			},
			{										-- zwrotnice
				"zwr01",
				"zwr02"
			},
			{										-- semafory
				{
					"a",								-- nazwa
					{									-- semafory za nim
						
					},
					{									-- powtarzacze
						
					},
					{									-- przebiegi
						{
							"1",							-- nazwa
							1,								-- sygnal
							"k",							-- nast. semafor
							{								-- zwrotnice
								"zwr01+"
							},
							{								-- izolacje
								"zwr1",
								"t1"
							}
						},
						{
							"2",							-- nazwa
							2,								-- sygnal
							"j",							-- nast. semafor
							{								-- zwrotnice
								"zwr01-"
							},
							{								-- izolacje
								"zwr1",
								"t2"
							}
						}
					}
				},
				{
					"b",								-- nazwa
					{									-- semafory za nim
						"p"
					},
					{									-- powtarzacze
						"psb1",
						"psb2"
					},
					{									-- przebiegi
						{
							"a",							-- nazwa
							2,								-- sygnal
							"null",							-- nast. semafor
							{								-- zwrotnice
								"zwr01-"
							},
							{								-- izolacje
								"zwr1",
								"szlak1_t1"
							}
						}
					}
				},
				{
					"c",								-- nazwa
					{									-- semafory za nim
						"p"
					},
					{									-- powtarzacze
						"psc1",
						"psc2"
					},
					{									-- przebiegi
						{
							"a",							-- nazwa
							1,								-- sygnal
							"null",							-- nast. semafor
							{								-- zwrotnice
								"zwr01+"
							},
							{								-- izolacje
								"zwr1",
								"szlak1_t1"
							}
						}
					}
				},
				{
					"j",								-- nazwa
					{									-- semafory za nim
						"a"
					},
					{									-- powtarzacze
						"psj1",
						"psj2"
					},
					{									-- przebiegi
						{
							"b",							-- nazwa
							2,								-- sygnal
							"null",							-- nast. semafor
							{								-- zwrotnice
								"zwr02-"
							},
							{								-- izolacje
								"zwr2",
								"szlak2_t1"
							}
						}
					}
				},
				{
					"k",								-- nazwa
					{									-- semafory za nim
						"a"
					},
					{									-- powtarzacze
						"psk1",
						"psk2"
					},
					{									-- przebiegi
						{
							"b",							-- nazwa
							1,								-- sygnal
							"null",							-- nast. semafor
							{								-- zwrotnice
								"zwr02+"
							},
							{								-- izolacje
								"zwr2",
								"szlak2_t1"
							}
						}
					}
				},
				{
					"p",								-- nazwa
					{									-- semafory za nim
						
					},
					{									-- powtarzacze
						
					},
					{									-- przebiegi
						{
							"1",							-- nazwa
							1,								-- sygnal
							"c",							-- nast. semafor
							{								-- zwrotnice
								"zwr02+"
							},
							{								-- izolacje
								"zwr2",
								"t1"
							}
						},
						{
							"2",							-- nazwa
							2,								-- sygnal
							"b",							-- nast. semafor
							{								-- zwrotnice
								"zwr02-"
							},
							{								-- izolacje
								"zwr2",
								"t2"
							}
						}
					}
				}
			}
		}
	},
	{										-- szlak 1
		"szlak1",
		"szlak1",
		1,
		{
			{
				"t1"
			},
			{
				
			},
			{
				
			}
		}
	},
	{										-- szlak 2
		"szlak2",
		"szlak2",
		1,
		{
			{
				"t1"
			},
			{
				
			},
			{
				
			}
		}
	}
}
)

polaczEvent("wjazd1", {{"podajPrzebieg", {"stacja1_a", "1", genOpoznienie("stacja1")}}, {"podajPrzebieg", {"stacja1_k", "b", genOpoznienie("stacja1")}}})
polaczEvent("wjazd2", {{"podajPrzebieg", {"stacja1_p", "2", genOpoznienie("stacja1")}}, {"podajPrzebieg", {"stacja1_b", "a", genOpoznienie("stacja1")}}})